{% extends "layout.html" %}

{% block title %}
{{ gallery['title'] }} - {{ config['title'] }}
{% endblock %}

{% block css %}
{{ super() }}
<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/fotorama/4.6.4/fotorama.min.css"
      integrity="sha512-bjwk1c6AQQOi6kaFhKNrqoCNLHpq8PT+I42jY/il3r5Ho/Wd+QUT6Pf3WGZa/BwSdRSIjVGBsPtPPo95gt/SLg=="
      crossorigin="anonymous"/>
{% endblock %}

{% block style %}
{{ super() }}
<style>
    .fotorama {
        background-color: #000;
        position: fixed;
        top: 0;
        left: 0;
        width: 100%;
        height: 100%;
        display: none;
    }
    .gallery {
        display: flex;
        flex-wrap: wrap;
    }

    .gallery > a {
        margin: 0.25rem;
    }

    .gallery::after {
        content: '';
        flex-grow: 1000000;
    }

    .gallery > a > img {
        display: block;
        width: 100%;
    }

    .gallery-section h2 {
        text-align: center;
        margin-top: 30px;
    }

    .gallery-section p {
        width: 70%;
        margin: 0 auto 20px;
    }

    footer {
        margin-top: 30px;
    }
</style>
{% endblock %}

{% block header_title %}
{{ gallery['title'] }}
{% endblock %}

{% block header_details %}
{{ gallery['details'] }}
{% endblock %}

{% block header_cover %}
{% if gallery['cover'] %}
{{ gallery['cover'] | media('fill-in', 2000, 300) }}
{% endif %}
{% endblock %}

{% block content %}
{% macro increment(dct, key, inc=1)%}
{% if dct.update({key: dct[key] + inc}) %} {% endif %}
{% endmacro %}

{% set counter = {'index': 0} %}
<div class="col gallery fotorama" data-width="100%" data-height="100%"
     data-keyboard="true"
     data-nav="false"
     data-click="true"
     data-swipe="true">
    {% for section in gallery['sections'] %}
    {% for image in section['images'] %}
    <img src="{{ image['url'] | media('fit-in', 2048, 1080) }}" data-caption="{{ image['caption'] }}" loading=lazy />
    {% endfor %}
    {% endfor %}
</div>

{% set counter = {'index': 0} %}
{% for section in gallery['sections'] %}
<div class="container-fluid">
    <div class="row">
        <div class="col gallery-section">
            <h2>{{ section['title'] }}</h2>
            <p>{{ section['details'] }}</p>
        </div>
    </div>
    <div class="row">
        <div class="col gallery">
            {% for image in section['images'] %}
            <a href="{{ image['url'] | media('fit-in', 2048, 1080) }}" class="gallery-photo" data-index="{{ counter.index }}" data-caption="{{ image['caption'] }}">
                <img src="{{ image['url'] | media('fit-in', 2000, 156) }}" class="thumbnail"
                     alt="{{ image['caption'] }}" loading=lazy>
            </a>
            {{ increment(counter, 'index') }}
            {% endfor %}
        </div>
    </div>
</div>
{% endfor %}
{% endblock %}
{% block javascript %}
{{ super() }}
<script src="https://cdnjs.cloudflare.com/ajax/libs/fotorama/4.6.4/fotorama.min.js"
        integrity="sha512-cWEytOR8S4v/Sd3G5P1Yb7NbYgF1YAUzlg1/XpDuouZVo3FEiMXbeWh4zewcYu/sXYQR5PgYLRbhf18X/0vpRg=="
        crossorigin="anonymous"></script>
<script>
    $(document).ready(function () {
        const $fotoramaDiv = $('.fotorama');
        $fotoramaDiv.hide();
        const fotorama = $fotoramaDiv.data('fotorama');
        $('div.gallery a').on('click', function (e) {
            e.preventDefault();
            fotorama.show($(this).attr('data-index'));
            $fotoramaDiv.show();
            return false;
        });
        $('img.thumbnail').one('load', function () {
            $(this).parent().css('flex-grow', this.width * this.height / 100);
            $(this).after().css('flex-basis', this.width)
        }).each(function () {
            if (this.complete) {
                $(this).trigger('load');
            }
        });
        $(document).keyup(function(e) {
            if (e.key === "Escape") {
                $fotoramaDiv.hide();
            }
        });

    });
</script>
{% endblock %}

